﻿using Microsoft.Extensions.DependencyInjection;
using System;

namespace NetCore_DI_Nativo
{
    public interface IRecepcaoService
    {
        string Saudacao(string nome);
    }

    public class RecepcaoService : IRecepcaoService
    {
        public string Saudacao(string nome) => $"Olá, {nome}";
    }

    public class Controller
    {
        private readonly IRecepcaoService _recepcaoService;
        public Controller(IRecepcaoService recepcaoService)
        {
            _recepcaoService = recepcaoService ??
            throw new ArgumentNullException(nameof(recepcaoService));
        }

        public string Ola(string nome) => _recepcaoService.Saudacao(nome);
    }

    class Program
    {
        static ServiceProvider RegistrarServices()
        {
            var services = new ServiceCollection();

            //services.AddSingleton<IRecepcaoService, RecepcaoService>();
            services.AddTransient<Controller>();

            return services.BuildServiceProvider();
        }

        static void Main(string[] args)
        {
            using (ServiceProvider container = RegistrarServices())
            {
                var controller = container.GetRequiredService<Controller>();
                string resultado = controller.Ola("Macoratti");
                Console.WriteLine(resultado);
            }
        }
    }
}
