﻿using System;

namespace NetCore_Usando_DI
{
    public interface IRecepcaoService
    {
        string Saudacao(string nome);
    }

    public class RecepcaoService : IRecepcaoService
    {
        public string Saudacao(string nome) => $"Olá, {nome}";
    }

    public class Controller
    {
        private readonly IRecepcaoService _recepcaoService;
        public Controller(IRecepcaoService recepcaoService)
        {
            _recepcaoService = recepcaoService ??
            throw new ArgumentNullException(nameof(recepcaoService));
        }

        public string Ola(string nome) => _recepcaoService.Saudacao(nome);
    }

    class Program
    {
        static void Main(string[] args)
        {
            var controller = new Controller(new RecepcaoService());
            string resultado = controller.Ola("Macoratti");
            Console.WriteLine(resultado);
        }
    }
}
